<script setup lang="ts" generic="T">
const props = defineProps<{
  items: T[];
  newItem: () => T;
  rules?: any[];
}>();

const emit = defineEmits<{
  (e: "update:items", v: T[]): void;
}>();

const remove = (itemToRemove: T) => {
  emit(
    "update:items",
    props.items.filter((item) => item !== itemToRemove),
  );
};

const newItem = () => {
  emit("update:items", [...props.items, props.newItem()]);
};

const update = (idxToUpdate: number, itemToUpdate: T) => {
  emit(
    "update:items",
    props.items.map((item, idx) => {
      return idxToUpdate === idx ? itemToUpdate : item;
    }),
  );
};
</script>

<template>
  <div>
    <template v-for="(item, idx) in props.items">
      <div class="d-flex align-center">
        <slot :item="item" :idx="idx" :update="update" />
        <v-icon icon="mdi-minus" @click="remove(item)" />
      </div>
    </template>
    <v-btn
      append-icon="mdi-plus"
      variant="flat"
      color="secondary"
      @click="newItem"
    >
      Add
    </v-btn>
  </div>
  <div class="mt-1">
    <v-text-field class="list-input-error" :rules="props.rules || []" />
  </div>
</template>

<style scoped>
:deep(.list-input-error .v-input__control) {
  display: none;
}
</style>
